(require-extension sxml-tools)
(require-extension srfi-13)

;; Some files use the obsolete let-values* form instead of
;; the SRFI-11 let*-values.
(define-macro (let-values* . args) `(let*-values ,@args))
; (define -- sub1)

(declare
 (export

;; xpath-ast
  txp:ast-operation-helper
  txp:ast-params
  txp:ast-res
  txp:ast-api-helper
  txp:xpath->ast
  txp:xpointer->ast
  txp:expr->ast
  txp:sxpath->ast
  txp:step?
  txp:step-axis
  txp:step-node-test
  txp:step-preds
  txp:construct-step

;; xpath-context
  sxml:context-u?
  sxml:context?
  sxml:context->node-u
  sxml:context->ancestors-u
  sxml:context->content-u
  sxml:context->node
  sxml:context->ancestors
  sxml:context->content
  draft:contextset->nodeset
  draft:make-context
  draft:smart-make-context
  draft:siblings->context-set
  draft:na+
  draft:na-minus
  draft:na-minus-nneg
  draft:na-max
  draft:na-min
  draft:na>
  draft:na>=
  draft:list-head
  draft:list-last
  draft:make-list
  draft:signal-semantic-error
  draft:top?
  draft:remove-eq-duplicates
  draft:reach-root
  draft:recover-contextset
  draft:find-proper-context
  draft:ancestor
  draft:ancestor-or-self
  draft:attribute
  draft:child
  draft:descendant
  draft:descendant-or-self
  draft:following
  draft:following-sibling
  draft:namespace
  draft:parent
  draft:preceding
  draft:preceding-sibling
  draft:self
  draft:core-last
  draft:core-position
  draft:core-count
  draft:core-id
  draft:core-local-name
  draft:core-namespace-uri
  draft:core-name
  draft:core-string
  draft:core-concat
  draft:core-starts-with
  draft:core-contains
  draft:core-substring-before
  draft:core-substring-after
  draft:core-substring
  draft:core-string-length
  draft:core-normalize-space
  draft:core-translate
  draft:core-boolean
  draft:core-not
  draft:core-true
  draft:core-false
  draft:core-lang
  draft:core-number
  draft:core-sum
  draft:core-floor
  draft:core-ceiling
  draft:core-round
  draft:ast-axis-specifier
  draft:ast-node-test
  draft:ast-location-path
  draft:ast-absolute-location-path
  draft:ast-relative-location-path
  draft:ast-step
  draft:ast-step-list
  draft:ast-predicate
  draft:ast-predicate-list
  draft:ast-expr
  draft:ast-or-expr
  draft:ast-and-expr
  draft:ast-equality-expr
  draft:ast-relational-expr
  draft:ast-additive-expr
  draft:ast-multiplicative-expr
  draft:ast-union-expr
  draft:ast-path-expr
  draft:ast-filter-expr
  draft:ast-variable-reference
  draft:ast-literal
  draft:ast-number
  draft:ast-function-call
  draft:ast-function-arguments
  draft:ast-xpointer
  draft:ast-child-seq
  draft:ast-number-list
  draft:ast-full-xptr
  draft:arglist->ns+na
  draft:api-helper
  draft:xpath
  draft:xpointer
  draft:xpath-expr
  draft:sxpath
  txpath-with-context
  txpath/c
  sxpath-with-context
  sxpath/c

;; ddo-axes
  ddo:list-last
  ddo:attr-child
  ddo:attrs-and-values
  ddo:discard-attributes
  ddo:ancestor
  ddo:ancestor-or-self
  ddo:attribute
  ddo:child
  ddo:descendant
  ddo:descendant-or-self
  ddo:following
  ddo:following-sibling
  ddo:namespace
  ddo:parent
  ddo:preceding
  ddo:preceding-sibling
  ddo:self
  ddo:following-single-level
  ddo:following-sibling-single-level
  ddo:parent-single-level
  ddo:preceding-single-level
  ddo:preceding-sibling-single-level
  ddo:ancestor-pos
  ddo:ancestor-or-self-pos
  ddo:child-pos
  ddo:descendant-pos
  ddo:descendant-or-self-pos
  ddo:following-sibling-pos
  ddo:parent-pos
  ddo:preceding-sibling-pos
  ddo:following-single-level-pos
  ddo:following-sibling-single-level-pos
  ddo:parent-single-level-pos
  ddo:preceding-single-level-pos
  ddo:preceding-sibling-single-level-pos

;; ddo-txpath
  ddo:or
  ; ddo:foldl
  ddo:foldr
  ddo:type-nodeset
  ddo:type-number
  ddo:type-string
  ddo:type-boolean
  ddo:type-any
  ddo:nset-contained?
  ddo:nset-equal?
  ddo:pos-result-forward?
  ddo:pos-result->nodeset
  ddo:location-step-pos
  ddo:location-step-non-intersect
  ddo:location-step-non-pos
  ddo:filter-expr-general
  ddo:filter-expr-non-pos
  ddo:filter-expr-special-predicate
  ddo:all-contexts-in-doc
  ddo:unite-2-contextsets
  ddo:unite-multiple-context-sets
  ddo:list-tail
  ddo:list-head
  ddo:list-ref
  ddo:check-ast-position?
  ddo:check4ast-number
  ddo:check-special-predicate
  ddo:check-ast-desc-os?
  ddo:rewrite-step*
  ddo:generate-pred-id
  ddo:get-pred-value
  ddo:get-pred-value-pos
  ddo:get-abs-lpath-value
  ddo:construct-pred-values
  ddo:construct-pred-values-pos
  ; ddo:evaluate-deep-predicates
  ddo:vector-copy-set
  ddo:add-vector-to-var-binding
  ddo:charlst->branch
  ddo:add-var-to-tree
  ddo:var-binding->tree
  ddo:get-var-value-from-tree
  ddo:ast-axis-specifier
  ddo:ast-location-path
  ddo:ast-absolute-location-path
  ddo:ast-relative-location-path
  ddo:ast-step
  ddo:ast-step-list
  ddo:ast-predicate
  ddo:ast-predicate-list
  ddo:ast-expr
  ddo:apply-ast-procedure
  ddo:ast-or-expr
  ddo:ast-and-expr
  ddo:ast-equality-expr
  ddo:ast-relational-expr
  ddo:ast-additive-expr
  ddo:ast-multiplicative-expr
  ddo:ast-union-expr
  ddo:ast-path-expr
  ddo:ast-filter-expr
  ddo:ast-variable-reference
  ddo:ast-literal
  ddo:ast-number
  ddo:ast-function-call
  ddo:ast-function-arguments
  ddo:api-helper
  ddo:txpath
  ddo:xpath-expr
  ddo:sxpath

;; modif
  sxml:modification-error
  sxml:separate-list
  sxml:assert-proper-attribute
  sxml:unite-annot-attributes-lists
  sxml:tree-trans
  sxml:transform-document
  sxml:lambdas-upd-specifiers->targets
  sxml:update-specifiers->lambdas
  modif:insert-following
  modif:insert-preceding
  modif:insert-into
  modif:rename
  modif:delete
  modif:delete-undeep
  sxml:modify
  sxml:clone
  sxml:clone-nset-except
  sxml:replace-next-with-lst!
  sxml:mutate-doc!
  sxml:nodes-to-mutate
  sxml:modify!

;; lazy-xpath
  lazy:or
  lazy:promise?
  lazy:null?
  lazy:map
  lazy:filter
  lazy:car
  lazy:cdr
  lazy:length
  lazy:result->list
  lazy:node->sxml
  lazy:reach-root
  lazy:contextset->nodeset
  lazy:recover-contextset
  lazy:find-proper-context
  lazy:output-siblings
  lazy:find-foll-siblings
  lazy:find-prec-siblings
  lazy:ancestor
  lazy:ancestor-or-self
  lazy:attribute
  lazy:child
  lazy:descendant
  lazy:descendant-or-self
  lazy:following
  lazy:following-sibling
  lazy:namespace
  lazy:parent
  lazy:preceding
  lazy:preceding-sibling
  lazy:self
  lazy:axis-consume-nodeset
  lazy:string
  lazy:boolean
  lazy:number
  lazy:string-value
  lazy:equality-cmp
  lazy:equal?
  lazy:not-equal?
  lazy:relational-cmp
  lazy:core-last
  lazy:core-position
  lazy:core-count
  lazy:core-id
  lazy:core-local-name
  lazy:core-namespace-uri
  lazy:core-name
  lazy:core-string
  lazy:core-concat
  lazy:core-starts-with
  lazy:core-contains
  lazy:core-substring-before
  lazy:core-substring-after
  lazy:core-substring
  lazy:core-string-length
  lazy:core-normalize-space
  lazy:core-translate
  lazy:core-boolean
  lazy:core-not
  lazy:core-true
  lazy:core-false
  lazy:core-lang
  lazy:core-number
  lazy:core-sum
  lazy:core-floor
  lazy:core-ceiling
  lazy:core-round
  lazy:ast-axis-specifier
  lazy:ast-location-path
  lazy:ast-absolute-location-path
  lazy:ast-relative-location-path
  lazy:ast-step
  lazy:ast-step-list
  lazy:ast-predicate
  lazy:ast-predicate-list
  lazy:ast-expr
  lazy:ast-or-expr
  lazy:ast-and-expr
  lazy:ast-equality-expr
  lazy:ast-relational-expr
  lazy:ast-additive-expr
  lazy:ast-multiplicative-expr
  lazy:ast-union-expr
  lazy:ast-path-expr
  lazy:ast-filter-expr
  lazy:ast-variable-reference
  lazy:ast-literal
  lazy:ast-number
  lazy:ast-function-call
  lazy:ast-function-arguments
  lazy:api-helper
  lazy:txpath
  lazy:xpath-expr
  lazy:sxpath
  ))

;; For sxpathlib, sxml-tools, sxpath-ext, xpath-parser, txpath, sxpath
(include "extras/output.scm") ;; cout cerr nl
(include "extras/string-utils.scm") ;; string-split substring? [txpath]
                                    ;; make-char-quotator [sxml-tools]

;; sxml-tools-extra
(include "sxml-tools/xpath-ast.scm")    ;; required for xpath-context.scm
(include "sxml-tools/xpath-context.scm")
(include "sxml-tools/ddo-axes.scm")     ;; requires xpath-ast, xpath-context
(include "sxml-tools/ddo-txpath.scm");; requires xpath-ast, xpath-context
(include "sxml-tools/modif.scm")        ;; requires ddo, xpath-context
(include "sxml-tools/lazy-xpath.scm")

;; xlink requires ssax:multi-parser, which
;; is not currently available for Chicken.
;(include "sxml-tools/xlink.scm")      
;(include "sxml-tools/xlink-parser.scm")

;(include "sxml-tools/guides.scm")       ;; ??
;(include "sxml-tools/fragments.scm")  ;; seems to be used in stx example
