;; For sxpathlib, sxml-tools and txpath
(require-extension srfi-13)  ;; string-prefix? string-prefix-ci? string-index-right
;; For sxml-tools and xpath-parser
(require-extension srfi-1)   ;; filter

(define sxml:error error)

;; Some files use the obsolete let-values* form instead of
;; the SRFI-11 let*-values.
(define-macro (let-values* . args) `(let*-values ,@args))
(define -- sub1)

(declare
 (export

;; sxpathlib
  nodeset?
  as-nodeset
  sxml:element?
  ntype-names??
  ntype??
  ntype-namespace-id??
  sxml:complement
  node-eq?
  node-equal?
  node-pos
  sxml:filter
  take-until take-after
  map-union
  node-reverse
  node-trace
  select-kids
  node-self
  node-join
  node-reduce
  node-or
  node-closure
  sxml:node?
  sxml:attr-list
  sxml:attribute
  sxml:child
  sxml:parent
  node-parent
  sxml:child-nodes
  sxml:child-elements

;; sxpath
  sxpath
  if-sxpath
  if-car-sxpath
  car-sxpath
  sxml:id-alist

;; sxml-tools
  sxml:empty-element?
  sxml:shallow-normalized?
  sxml:normalized?
  sxml:shallow-minimized?
  sxml:minimized?
  sxml:name
  sxml:element-name
  sxml:node-name
  sxml:ncname
  sxml:name->ns-id
  sxml:content
  sxml:text
  sxml:content-raw
  sxml:attr-list-u
  sxml:aux-list
  sxml:aux-list-u
  sxml:aux-node
  sxml:aux-nodes
  sxml:attr
  sxml:attr-from-list
  sxml:num-attr
  sxml:attr-u
  sxml:ns-list
  sxml:ns-id->nodes
  sxml:ns-id->uri
  sxml:ns-uri->nodes
  sxml:ns-uri->id
  sxml:ns-id sxml:ns-uri
  sxml:ns-prefix
  sxml:change-content!
  sxml:change-content
  sxml:change-attrlist
  sxml:change-attrlist!
  sxml:change-name!
  sxml:change-name
  sxml:add-attr
  sxml:add-attr!
  sxml:change-attr
  sxml:change-attr!
  sxml:set-attr
  sxml:set-attr!
  sxml:add-aux
  sxml:add-aux!
  sxml:squeeze!
  sxml:squeeze
  sxml:clean
  select-first-kid
  sxml:node-parent
  sxml:add-parents
  sxml:lookup
  sxml:attr->xml
  sxml:string->xml
  sxml:sxml->xml
  sxml:attr->html
  sxml:string->html
  sxml:non-terminated-html-tag?
  sxml:sxml->html

;; sxpath-ext
  sxml:string
  sxml:boolean
  sxml:number
  sxml:string-value
  sxml:id
  sxml:list-head
  sxml:merge-sort
  sxml:equality-cmp
  sxml:equal?
  sxml:not-equal?
  sxml:relational-cmp
  sxml:ancestor
  sxml:ancestor-or-self
  sxml:descendant
  sxml:descendant-or-self
  sxml:following sxml:following-sibling
  sxml:namespace
  sxml:preceding sxml:preceding-sibling

;; xpath-parser
  txp:parameterize-parser
  sxml:whitespace
  txp:signal-semantic-error
  txp:error?

;; txpath
  sxml:core-last
  sxml:core-position
  sxml:core-count
  sxml:core-id
  sxml:core-local-name
  sxml:core-namespace-uri
  sxml:core-name
  sxml:core-string
  sxml:core-concat
  sxml:core-starts-with
  sxml:core-contains
  sxml:core-substring-before sxml:core-substring-after
  sxml:core-substring
  sxml:core-string-length
  sxml:core-normalize-space
  sxml:core-translate
  sxml:core-boolean
  sxml:core-not
  sxml:core-true
  sxml:core-false
  sxml:core-lang
  sxml:core-number
  sxml:core-sum
  sxml:core-floor
  sxml:core-ceiling
  sxml:core-round
  sxml:classic-params
  sxml:xpath
  sxml:xpointer
  sxml:xpath-expr
  sxml:xpath+index
  sxml:xpath+root
  sxml:xpath+root+vars
  sxml:xpointer+index
  sxml:xpointer+root+vars
  txpath
  
;; sxml-errors (actually, defined here)
  sxml:error))

;; For sxpathlib, sxml-tools, sxpath-ext, xpath-parser, txpath, sxpath
;; We don't want these two visible outside this extension.
(include "extras/output.scm") ;; cout cerr nl
(include "extras/string-utils.scm") ;; string-split substring? [txpath]
                                    ;; make-char-quotator [sxml-tools]

;; sxml-tools
(include "sxml-tools/sxpath.scm")
(include "sxml-tools/sxpathlib.scm")
(include "sxml-tools/sxpath-ext.scm")
(include "sxml-tools/sxml-tools.scm")
(include "sxml-tools/xpath-parser.scm")  ;; defines txp:parameterize-parser; required by txpath.scm
(include "sxml-tools/txpath.scm")
